----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    14:30:37 03/01/2015 
-- Module Name:    MixInvMixColumns - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity MixInvMixColumns is
    Port ( input   : in  STD_LOGIC_VECTOR (127 downto 0);
			  encrypt : in  STD_LOGIC;
           output  : out STD_LOGIC_VECTOR (127 downto 0));
end MixInvMixColumns;

architecture Behavioral of MixInvMixColumns is
	
	COMPONENT MixInvMixOneColumn is
	Port ( input   : in  STD_LOGIC_VECTOR (31 downto 0);
			 encrypt : in  STD_LOGIC;
			 output  : out STD_LOGIC_VECTOR (31 downto 0));
	end COMPONENT;

	type ColumnWordType is array(0 to 3) of std_logic_vector(31 downto 0);
	signal	InColumns	: ColumnWordType;
	signal 	OutColumns  : ColumnWordType;

begin

	GenInWords:
	for i in 0 to 3 generate
			InColumns(i) <= input(((16-4*i)*8-1) downto ((12-4*i)*8));
	end generate GenInWords;

	GenMixColumns:
	for i in 0 to 3 generate
		MixInvMixOneColumnInst: MixInvMixOneColumn
		port map(
			input 	=> InColumns(i),	
			encrypt  => encrypt,
			output 	=> OutColumns(i));
	end generate GenMixColumns;

	GenOutWords:
	for i in 0 to 3 generate
			output(((16-4*i)*8-1) downto ((12-4*i)*8)) <= OutColumns(i);
	end generate GenOutWords;

end Behavioral;

