----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    11:48:25 03/01/2015 
-- Module Name:    SubInvSubBytes - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity SubInvSubBytes is
    Port ( input  	: in  STD_LOGIC_VECTOR (127 downto 0);
			  encrypt	: in  STD_LOGIC;
           output 	: out STD_LOGIC_VECTOR (127 downto 0));
end SubInvSubBytes;

architecture Behavioral of SubInvSubBytes is

	COMPONENT bSbox IS
	PORT ( A     	: IN  STD_LOGIC_VECTOR (7 DOWNTO 0);
			 encrypt	: IN  STD_LOGIC;
			 Q			: OUT STD_LOGIC_VECTOR (7 DOWNTO 0));
	END COMPONENT;

begin

	GenSubBytes:
	FOR i IN 0 TO 15 GENERATE
		Inst_Sbox: bSbox
		PORT MAP (
			A 			=> input (((i+1)*8-1) downto i*8),
			encrypt	=> encrypt,
			Q   		=> output(((i+1)*8-1) downto i*8));
	END GENERATE GenSubBytes;
	
end Behavioral;

