----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    15:28:03 31/12/2014 
-- Module Name:    ff_FDER - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

ENTITY ff_FDER IS
	PORT ( clk : IN  STD_LOGIC;
			 D   : IN  STD_LOGIC;
			 clr : IN  STD_LOGIC;
			 en  : IN  STD_LOGIC;
			 Q   : OUT STD_LOGIC);
END ff_FDER;

ARCHITECTURE behavioral OF ff_FDER IS
	
	SIGNAL current_state : STD_LOGIC;
	
BEGIN

	FLIP_FLOP: PROCESS(clk, en, clr)
	BEGIN
		IF RISING_EDGE(clk) THEN
			IF clr = '1' THEN
				current_state <= '0';
			ELSIF en = '1' THEN
				current_state <= D;
			ELSE
				current_state <= current_state;
			END IF;
		END IF;
	END PROCESS;
		
	Q <= current_state;
	
END;

