----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    15:28:03 31/12/2014 
-- Module Name:    ff_SDE - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.NUMERIC_STD.ALL;

ENTITY ff_SDE IS
	PORT ( clk : IN  STD_LOGIC;
			 D0  : IN  STD_LOGIC;
			 D1  : IN  STD_LOGIC;
			 sel : IN  STD_LOGIC;
			 en  : IN  STD_LOGIC;
			 Q   : OUT STD_LOGIC);
END ff_SDE;

ARCHITECTURE behavioral OF ff_SDE IS
	
	SIGNAL current_state, next_state : STD_LOGIC;
	
BEGIN

	next_state <= D0 WHEN sel = '0' ELSE D1;

	FLIP_FLOP: PROCESS(clk, en)
	BEGIN
		IF RISING_EDGE(clk) THEN
			IF en = '1' THEN
				current_state <= next_state;
			ELSE
				current_state <= current_state;
			END IF;
		END IF;
	END PROCESS;
		
	Q <= current_state;
	
END;

