----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    15:28:03 31/12/2014 
-- Module Name:    reg_FDE - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY reg_FDE IS
	GENERIC ( size: POSITIVE := 128);
	PORT ( clk  : IN  STD_LOGIC;
			 D    : IN  STD_LOGIC_VECTOR ((size-1) DOWNTO 0);
			 en   : IN  STD_LOGIC;
			 Q    : OUT STD_LOGIC_VECTOR ((size-1) DOWNTO 0));
END reg_FDE;

ARCHITECTURE behavioral OF reg_FDE IS
	
	COMPONENT ff_FDE
	PORT ( clk : IN  STD_LOGIC;
			 D   : IN  STD_LOGIC;
			 en  : IN  STD_LOGIC;
			 Q   : OUT STD_LOGIC);
	END COMPONENT;
	
BEGIN

	gen_Reg_FDE:
	FOR i IN 0 TO size-1 GENERATE
		Inst_ff_FDE: ff_FDE
		PORT MAP (
			clk => clk,
			D   => D(i),
			en  => en,
			Q   => Q(i));
	END GENERATE gen_Reg_FDE;
			
END;

