----------------------------------------------------------------------------------
-- Ruhr-University Bochum, Germany
-- Amir Moradi (amir.moradi@rub.de)
-- 
-- Last Update:    15:28:03 31/12/2014 
-- Module Name:    reg_FDER - Behavioral 
-- Project Name:   POET 2
----------------------------------------------------------------------------------

LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY reg_FDER IS
	GENERIC ( size: POSITIVE := 128);
	PORT ( clk  : IN  STD_LOGIC;
			 D    : IN  STD_LOGIC_VECTOR ((size-1) DOWNTO 0);
			 clr  : IN  STD_LOGIC;
			 en   : IN  STD_LOGIC;
			 Q    : OUT STD_LOGIC_VECTOR ((size-1) DOWNTO 0));
END reg_FDER;

ARCHITECTURE behavioral OF reg_FDER IS
	
	COMPONENT ff_FDER
	PORT ( clk : IN  STD_LOGIC;
			 D   : IN  STD_LOGIC;
			 clr : IN  STD_LOGIC;
			 en  : IN  STD_LOGIC;
			 Q   : OUT STD_LOGIC);
	END COMPONENT;
	
BEGIN

	gen_Reg_FDER:
	FOR i IN 0 TO size-1 GENERATE
		Inst_ff_FDER: ff_FDER
		PORT MAP (
			clk => clk,
			D   => D(i),
			clr => clr,
			en  => en,
			Q   => Q(i));
	END GENERATE gen_Reg_FDER;
			
END;

